
#ifndef COMPONENTPROXY_H
#define COMPONENTPROXY_H

#include <kore/kore.h>

namespace kore
{
    class KORE_API Interface;
    class KORE_API MetaInfo;
    class ComponentProxyPrivate;

    class KORE_API ComponentProxy
    {
    public:
        ComponentProxy();
        ComponentProxy( MetaInfo* info );
        ComponentProxy( MetaInfo* info, Interface* inst );
        virtual ~ComponentProxy();

        virtual Interface* instance();
        virtual Interface* newInstance();
        virtual MetaInfo* metaInfo();
        virtual void setInstance( Interface* inst );
    private:
        ComponentProxyPrivate* _d;
    };
};

#endif
