
#ifndef LIBRARYLOCATOR_H
#define LIBRARYLOCATOR_H

#include <kore/interface.h>

namespace kore
{
    class KORE_API Library;

    class KORE_API LibraryLocator: public Interface
    {
    public:
        LibraryLocator();
        virtual ~LibraryLocator();

        virtual void scanLibrary( const char* name, const char* path = 0, int flags = 0 );
        virtual void scanLibrary( Library* lib );
        virtual void scanDir( const char* path, bool recurse = false, int flags = 0 );
    };
};

#endif
