#ifndef RWBACKEND_H
#define RWBACKEND_H

#include <kore/kore.h>
#include <kore/robackend.h>
#include <kore/wrbackend.h>

namespace kore
{

class KORE_API ReadWriteBackend : virtual public ReadOnlyBackend, virtual public ReadWriteBackend
{
public:
    virtual ~ReadWriteBackend();

    virtual bool canRead() = 0;
    virtual bool canWrite() = 0;
};

};

#endif
